'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.upDir = exports.getCallerFile = exports.capitalize = exports.Response = exports.Router = exports.middlewares = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _middlewares = require('./middlewares');

var _middlewares2 = _interopRequireDefault(_middlewares);

var _Router = require('./Router');

var _Router2 = _interopRequireDefault(_Router);

var _Response = require('./Response');

var _Response2 = _interopRequireDefault(_Response);

var _capitalize = require('./lib/capitalize');

var _capitalize2 = _interopRequireDefault(_capitalize);

var _getCallerFile = require('./lib/getCallerFile');

var _getCallerFile2 = _interopRequireDefault(_getCallerFile);

var _upDir = require('./lib/upDir');

var _upDir2 = _interopRequireDefault(_upDir);

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

exports.middlewares = _middlewares2.default;
exports.Router = _Router2.default;
exports.Response = _Response2.default;
exports.capitalize = _capitalize2.default;
exports.getCallerFile = _getCallerFile2.default;
exports.upDir = _upDir2.default;

var App = function () {
  function App() {
    _classCallCheck(this, App);

    this.port = 6060;
    this.prefix = '';
  }

  _createClass(App, [{
    key: 'run',
    value: function run() {
      var routes = void 0,
          controllers = void 0,
          port = void 0;
      var base = this.base = process.cwd() + '/' + this.prefix;

      controllers = base + '/controllers';

      try {
        routes = require(base + '/routes').default;

        try {
          routes = require(base + '/routes');
        } catch (e) {
          throw new Error('app must have the "routes" directory with index file near her');
        }
      } catch (e) {}

      try {
        port = require(base + '/config').port;
      } catch (e) {}

      _Router2.default.setControllersPath(controllers);

      return _http2.default.createServer(function (req, res) {
        (0, _logger2.default)(req, res);

        _Router2.default.route(req, res);
      }).listen(port);
    }
  }, {
    key: 'set',
    value: function set(key, val) {
      this[key] = val;
    }
  }, {
    key: 'get',
    value: function get(key) {
      if (this[key]) return this[key];else return undefined;
    }
  }]);

  return App;
}();

App.displayName = 'App';
exports.default = new App();