import middlewares from './middlewares';
import Router from './Router';
import Response from './Response';
import capitalize from './lib/capitalize';
import getCallerFile from './lib/getCallerFile';
import upDir from './lib/upDir';

import http from 'http';
import logger from './logger';

export {
  middlewares,
  Router,
  Response,
  capitalize,
  getCallerFile,
  upDir,
};

class App {

  port = 6060;
  prefix = '';
  base;

  run() {
    let routes, controllers, port;
    let base = this.base = `${process.cwd()}/${this.prefix}`;

    controllers = `${base}/controllers`;

    try {
      routes = require(`${base}/routes`).default;

      try {
        routes = require(`${base}/routes`);
      } catch(e) {
        throw new Error('app must have the "routes" directory with index file near her')
      }
    } catch(e) {}


    try {
      port = require(`${base}/config`).port;
    } catch(e) {}

    Router.setControllersPath(controllers);

    return http.createServer((req, res) => {
      logger(req, res);

      Router.route(req, res);
    }).listen(port);
  }

  set(key, val) {
    this[key] = val;
  }

  get(key) {
    if (this[key]) return this[key];
    else return undefined;
  }

}

export default new App();
